﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WhiteBoxTest
{
    /// <summary>
    /// Класс, в котором происходят все вычисления.
    /// <param name="listUnit">Элемент массива</param>
    /// <param name="count">Счётчик элементов, удовлетворяющих условию</param>
    /// <param name="sum">Сумма элементов, удовлетворяющих условию</param>
    /// <param name="avg">Среднее значение элементов, удовлетворяющих условию</param>
    /// <param name="firstIdZero">Идентификатор первого нуля</param>
    /// <param name="lastIdZero">Идентификатор последнего нуля</param>
    /// </summary>
    //Класс для ввода и вывода массива
    class MassClass
    {
        private List<double> classArray;
        private int classArraySize;
        public MassClass(List<double> array, int n)
        {
            this.classArraySize = n;
            this.classArray = array;
            this.classArray = InputMass(classArraySize);
            PrintMass(classArraySize, classArray);
            Console.WriteLine("Среднее значение - " + AverageValue(classArraySize, classArray));
        }
        //Метод ввода массива
        static List<double> InputMass(int n)
        {
            double listUnit;
            List<double> array = new List<double>();
            Console.WriteLine("Заполните массив: ");
            for (int i = 0; i < n; i++)
            {
                Console.WriteLine("Введите [{0}] элемент: ", i);
                listUnit = Convert.ToDouble(Console.ReadLine());
                array.Add(listUnit);
            }
            return array;
        }
        //Метод вывода массива
        static void PrintMass(int n, List<double> array)
        {
            Console.WriteLine("Итоговый массив: ");
            for (int i = 0; i < n; ++i)
            {
                Console.Write(array[i] + " ");
            }
            Console.WriteLine("");
        }
        //Метод расчёта срденего значения среди чисел, находящихся между нулями
        static double AverageValue(int n, List<double> array)
        {
            try
            {
                int count = 0;
                double sum = 0;
                int firstIdZero = array.FindIndex(x => x == 0), lastIdzZero = array.FindLastIndex(x => x == 0);
                double avg = 0;
                if (firstIdZero == lastIdzZero)
                {
                    Console.WriteLine("В массиве присутсвует только одно нулевое значение или такое значение отсутсвует вовсе, с подобными условиями задача не решаема!");
                    return 1;
                }
                for (int i = firstIdZero + 1; i < lastIdzZero; i++)
                {
                    sum += array[i];
                    count++;
                }
                avg = sum / count;
                return avg;
            }
            catch (Exception message)
            {
                Debug.WriteLine(message.Message);
                return 1;
            }
        }
    }

}
